#include   <fcntl.h>
#include   <errno.h>
#include   <sys/time.h>
#include  <stdio.h>
#include   "can_proto.h"

#define STDDEV "can"

/*------ main -------------------------------------------------------*/
int
main(int argc, char *argv[])
{
	int     fd, i, sent, got;
	canmsg_t rx, tx;
	char device[40];
	time_t           jetzt, anfang_zeit, ende_zeit, null_punkt = 0;
 
	if(argc == 2) {
		sprintf(device, "/dev/%s", argv[1]);
	}
	else {
		sprintf(device, "/dev/%s", STDDEV);
	}
	printf("using CAN device %s\n", device);

	if (( fd = can_Init(device, O_RDONLY)) < 0 ) {
		fprintf(stderr,"Error opening CAN device %s\n", device);
		exit(1);
	}

	/* read answer */
	while (can_Receive(fd, &rx) >0) {
		jetzt = rx.timestamp.tv_sec;
		printf("%ld,%ld Sek. ", rx.timestamp.tv_sec, rx.timestamp.tv_usec);

		printf(": id=%03x len=%d flags=0x%x msg:'",
			rx.id, rx.length, rx.flags );
		for (i=0;i<rx.length;i++) printf("%0x,", rx.data[i]);
		 printf("'\n");
		fflush(stdout);
	}
	close(fd);

}
