#include   <termios.h>
#include   <unistd.h>

#include   <fcntl.h>
#include   <errno.h>
#include   <sys/time.h>
#include   "can_proto.h"
#include  <stdio.h>

#define STDDEV "can"
/* symlink to /dev/ttyS0 */

void  usage(char *progname);
void  select_ea(void);


static struct termios   alt_terminal;
static int              alt_ttyfd = -1;
static enum { RESET, RAW, CBREAK } tty_modus = RESET;

/*------ tty_atexit --- mit atexit(tty_atexit) einzurichten ----------*/
void tty_atexit(void)
{
   if (alt_ttyfd >= 0)
      tty_reset(alt_ttyfd);
}

/*------ main -------------------------------------------------------*/
int
main(int argc, char *argv[])
{
	int     fd, i, j, sent, got, count;
	canmsg_t rx, tx;
	char device[40];
	char line[20];

	if(argc == 2) {
		sprintf(device, "/dev/%s", argv[1]);
	}
	else {
		sprintf(device, "/dev/%s", STDDEV);
	}
	printf("using CAN device %s\n", device);
        
	if (( fd = can_Init(device, O_WRONLY)) < 0 ) {
		fprintf(stderr,"Error opening CAN device %s\n", device);
		exit(1);
	}

	tx.id=0;
	while (fgets(line,18,stdin)) {
		//fprintf(stderr,"%d\n",strlen(line));
		if (strlen(line) > 2) {
			sscanf(line,"%8s",tx.data);
		} else {	
			sscanf(line,"%d",&count);
			tx.flags=0;
			for(j=0;j<count;j++) 
				*(tx.data + j) = 60+j+tx.id;
			*(tx.data + j) = 0;
		}
		tx.length = strlen(tx.data);
		//strncpy(tx.data,"abcdefgh",count);
		for(i=0;i<10;i++) {
			sent=can_Send(fd, &tx ); 
			if (sent < 0)
				printf("not ready");
			else
				printf("Sent id=%03x len=%d msg='%s' flags=0x%x \n",
						tx.id, tx.length, tx.data ,tx.flags );
		}
		tx.id = (tx.id + count) % 60;
	}
	close(fd);

}
