
#include  <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>
#include <ctype.h>
#include <slang.h>

#include <readline/readline.h>
#include <readline/history.h>
#include "can_proto.h"

#define STDDEV "can"
/* A static variable for holding the line. */
static char *line_read = (char *)NULL;

/* Read a string, and return a pointer to it.  Returns NULL on EOF. */
char * rl_gets ()
{
	/* If the buffer has already been allocated, return the memory
	   to the free pool. */
	if (line_read)
	{
		free (line_read);
		line_read = (char *)NULL;
	}

	/* Get a line from the user. */
	line_read = readline (">");

	/* If the line has any text in it, save it on the history. */
	if (line_read && *line_read)
		add_history (line_read);

	return (line_read);
}


int main(int argc,char **argv) {
	int fd;
	canmsg_t tx[80];
	//struct timeval tv;
	char *command;
	char *token;
	char zeich = 0;

	char device[40];

	printf("Welcome to CANterm (c) 1998 by C.Schroeter (clausi@chemie.fu-berlin.de)\nplease type 'help' for command info and 'q' for exit. \n \n");

	if(argc >= 2) {
		sprintf(device, "/dev/%s", argv[1]);
	}
	else {
		sprintf(device, "/dev/%s", STDDEV);
	}
	printf("using CAN device %s\n", device);

	if(( fd = open(device, O_WRONLY )) < 0 ) {
		fprintf(stderr,"Error opening CAN device %s\n", device);
		exit(1);
	}

	while(1) {
		zeich = 0;
		command = rl_gets(">");
		token=strtok(command," ");
		if( token != NULL )
  			if( token[0] == 'h' && !strncmp(token,"help",4) ) {
				printf("send ID:string\nbsend ID;n,n,..\nRTR ID\n");
				exit(0);
			}
	  		else if( token[0] == 'q' && !strncmp(token,"quit",4) ) {
				printf("exiting...\n");
				exit(0);
			}
			else if( token[0] == 's' && !strncmp(token,"send",4) ) {
				int id;
				char msg[80];
				int sent=0;

				if((token=strtok(NULL," ") )!= NULL ) {
					sscanf(token,"%d:%s",&id,msg);
					printf("\n ID=%d msg=%s",id,msg); fflush(stdout);
					tx[0].flags=0;
					tx[0].length=strlen(msg);
					tx[0].id=id;
					tx[0].cob=0;
					strcpy(tx[0].data,msg);
					sent = can_Send(fd,tx);
					if(sent > 0 ) printf(" OK\n"); fflush(stdout);
				} else {
					printf("usage: send id:string \n");
				}
			}
			else if( token[0] == 'R' && !strncmp(token,"RTR",3) ) {
				int id;
				int sent=0;

				if((token=strtok(NULL," ")) != NULL) {
					sscanf(token,"%d",&id);
					printf("\n ID=%d RTR",id); fflush(stdout);
					tx[0].flags= MSG_RTR;
					tx[0].id = id;
					sent = can_Send(fd,tx);
					if(sent > 0 ) printf(" OK\n"); fflush(stdout);
				} else {
					printf("usage: RTR id \n");
				}
			}
			else if( token[0] == 'b' && !strncmp(token,"bsend",5) ) {
				int id,j;
				char *token;
				int sent=0;

				if((token = strtok(NULL,":")) != NULL) {
					if( token != NULL ) {
						sscanf( token ,"%d",&id);
						printf("\n ID=%d ",id);
						j=0;
						while( (token = strtok(NULL,",")) != NULL ) {
							printf("'%c' ",strtol(token,NULL,0) );
							tx[0].data[j++] = strtol(token,NULL,0);
						}
						tx[0].flags=0;
						tx[0].length=j;
						tx[0].id=id;
						tx[0].cob=0;
						sent = can_Send(fd,tx);
						if(sent > 0 ) printf(" OK\n"); fflush(stdout);
						SLang_init_tty(-1, 0, 1);
						SLtt_get_terminfo();
						SLsmg_init_smg();

						while ((zeich = SLang_getkey()) != 'q') {
							if (zeich == '+') tx[0].data[0]++;
							if (zeich == '-') tx[0].data[0]--;
							if (!SLang_input_pending(0)){
								sent = can_Send(fd,tx);
								SLsmg_gotorc(SLtt_Screen_Rows-2, 3);
								SLsmg_printf("Byte %d",tx[0].data[0]);
								SLsmg_refresh(); 
							}
						}
						SLsmg_reset_smg();
						SLang_reset_tty();

					}
				} else {
					printf("usage: bsend id:binary[,binary...] \n");
				}
			}
		fflush(stdout);
	}

	if (line_read) free (line_read);
	close(fd);
	exit(0);

}

