#!/usr/bin/perl -w
#use strict var, subs;
use Tk;
use Tk::BrowseEntry;
use Carp;
use Cwd;
use POSIX ":sys_wait_h";
use Can;

# Widgets
my $w_start;                              # start button widget
my $w_top;                                # top level widget
my $w_list;                               # canvas
my $FSref;
my $file;
my $dir;

my @msg;

my $AutoSave;
my $overwrite;
my $cut;
my $play;

sub reread { 
  my ($w) = @_;
  my $pwd = Cwd::getcwd();
  if (chdir($dir))  {
    my $new = Cwd::getcwd();
    if ($new) {$dir = $new;}
    else {carp "Cannot getcwd in '$dir'" unless ($new);}
    chdir($pwd) || carp "Cannot chdir($pwd) : $!"; 
  }
  
  if (opendir(DIR, $dir))  {               
    $w->Subwidget('dir_list')->delete(0, "end");      
    foreach (sort(readdir(DIR))) { 
      #print $_,m#mp3$#,-d "$dir/$_","\n";
      #next if m#^[\.\#]\w+#;        # ohne Dotfiles, aber mit '..'                   
      #next if m#~$#;                # ohne Backups           
      $w->Subwidget('dir_list')->insert('end', $_) if  (m#mp3$# || -d "$dir/$_") ;
    }                                               
    closedir(DIR);                                   
  }
} 

sub Accept_dir   {
  my ($cw,$new) = @_;
  my @mp3;
  if (-d "$dir/$new")  {
    $dir = "$dir/$new";
    reread($w_top);
  }
  else {
     $file = "$dir/$new";
    # print "$dir/$new\n";
    play() if $play;
    @info = split(/\|/,`mp3info -F1 $file`,18);
    if ($info[6] == -1) {
      $Title = "";
      $Artist  = $Year = "" if $overwrite;
    } else {
      ($Title,$Artist,$Album,$Year,$x,$GenreT,$GenreN,$Rest)=@info;
      $GenreT = $GenreN . " " . $GenreT;
    }
    $Length= "$info[15]m $info[16]s";
  }
}

my $lb;

sub init {
  $w_top = MainWindow->new(-title => 'CAN - Explorer');

  my $menubar = $w_top->Frame(-relief => 'raised', -borderwidth => 2);
  $menubar->pack(side => 'top',  -fill => 'x');
  my $f = $menubar->Menubutton(qw/-text File -justify left -underline 0 -menuitems/ =>
     [
      [Checkbutton => 'Immer speichern', variable => \$AutoSave],
      [Checkbutton => 'berschreiben', variable => \$overwrite],
      [Checkbutton => '1.Frame wegschneiden', variable => \$cut],
      [Checkbutton => 'Anspielen', variable => \$play],
     # [Button => 'Setup ...',   command => [\&menus_error2, 'Setup']],
      [Separator => ''],
      [Button => 'Quit',        command => sub {exit(0)}],
     ])->grid(qw/-row 0 -column 0 -sticky w/);

  # Create directory scrollbox, place at the left
  $lb = $w_top->Component(ScrlListbox    => 'dir_list', 
			    -scrollbars    => 'se');
  $lb->pack(side => 'left', -expand => 1, -fill => 'both');
  $lb->bind('<Button-1>' => [\&Accept_dir, Ev(['getSelected'])]);
  $lb->bind('<space>' => [\&Accept_dir, Ev(['getSelected'])]);

  for (1..8) {
    my $f = $w_top->Frame(qw/-borderwidth 2/);
    my $e = $f->Entry(relief => 'sunken', width => 8, textvariable => eval('\$msg[$_]'));
    my $l = $f->Label(-text => "Byte$_:");
    $f->pack(qw/-side top -fill x/);
    $e->pack(qw/-side right/);       
    $l->pack(qw/-side left/);        
  }        
  my $f = $w_top->Frame(qw/-borderwidth 2/);
  my $e =  $f->BrowseEntry(relief => 'sunken', width => 5, -variable => \$Id);
  my $l = $f->Label(-text => 'MsgId:');
  for (2,4,6) {
    $e->insert("end", "$_");
}  
    $f->pack(qw/-side top -fill x/);
    $e->pack(qw/-side right/);       
    $l->pack(qw/-side left/);        

                    
  $w_start = $w_top->Button(text => 'Senden', command => \&send, underline =>0);
#  my $w_quit = $w_top->Button(text => 'Quit', command => sub {exit(0)});
#  my $w_quit = $w_top->Button(text => 'Quit', command => \&quit_play);
  my $w_play = $w_top->Button(text => 'Play', command => \&play);
  my $w_playE = $w_top->Button(text => '1>', command => \&playE);
  my $w_cut = $w_top->Button(text => 'cut', command => \&cut);

  $w_start->pack('-side'=> 'left', '-fill' => 'x', '-expand' => 'x');
  $w_play->pack('-side'=> 'left');
  $w_playE->pack('-side'=> 'left');
  $w_cut->pack('-side'=> 'right', '-fill' => 'x', '-expand' => 'x');
#  $w_quit->pack('-side'=> 'right', '-fill' => 'x', '-expand' => 'x');
  
  $w_top->bind('<Control-s>' => \&send);

  $dir = ".";
  reread($w_top);

}

sub send {
	my $lenght=2;
	my $can_msg=pack("S".'c' x $lenght,($Id<<5)+$lenght,@msg);
	print CAN 'C'.$can_msg;
  
}

sub bintodec {
	unpack("N", pack("B32", substr("0" x 32 . shift, -32)));
}

$|=1;
open(CAN, ">/dev/can") || die "Cannot open /dev/can";
#open(CAN, ">qqq") || die "Cannot open /dev/can";

init();

MainLoop();

__END__  

Tie: Stdout an Textfeld






