#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "caracad_client.h"
#include <sys/uio.h>   /* struct iov */

#define PUFF_GROESSE   8192
#define MAX_ZEICHEN    92

static int server_open(char *name, int openflag);
int rec_fd(int spipefd, ssize_t (*benutzerfunk)(int, const void *, size_t));
int  cli_connect(const char *name);
/*--------- main -----------------------------------------------------
 */
int main(int argc, char *argv[])
{
	int     n, fd;
	long    zeichzahl;
	char    puffer[PUFF_GROESSE], zeile[MAX_ZEICHEN];

	while (fgets(zeile, MAX_ZEICHEN, stdin) != NULL) {
		zeile[strlen(zeile) - 1] = '\0'; /* \n mit \0 ueberschreiben */
		zeichzahl = 0;
		if ( (fd = server_open(zeile, O_RDONLY)) >= 0) {
			while ( (n = read(fd, puffer, PUFF_GROESSE)) > 0) {
				zeichzahl += n;
				if (write(STDOUT_FILENO, puffer, n) != n)
					fprintf(stderr, "write-Fehler");
			}
			fprintf(stderr, "---- %s: %ld Zeichen ---\n", zeile, zeichzahl);
			close(fd);
		}
	}
	exit(0);
}

/*--------- server_open ----------------------------------------------
 *             sendet den Dateinamen und open-Flags an den entspr.
 *             open-Server und empfaengt dann den Filesdeskriptor
 *             fuer die von diesem Server geoeffnete Datei          */
static int server_open(char *name, int openflag)
{
	char           puffer[10];
	struct iovec   iov[3];
	static int     csfd = -1;  /* server connection */

	if (csfd < 0) {  
		if ( (csfd = cli_connect(CS_NAME)) < 0)
			fprintf(stderr, "cli_verbind-Fehler");
	}
	sprintf(puffer, " %d", openflag);
	iov[0].iov_base = "open ";
	iov[0].iov_len  = strlen("open ");
	iov[1].iov_base = name;
	iov[1].iov_len  = strlen(name);
	iov[2].iov_base = puffer;
	iov[2].iov_len  = strlen(puffer)+1; /* +1 wegen abschl. \0 */
	if (writev(csfd, &iov[0], 3) !=
			iov[0].iov_len + iov[1].iov_len + iov[2].iov_len)
		fprintf(stderr, "writev-Fehler");

	return( rec_fd(csfd, write) );
}
